> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/signing/encodestructureddata.md).

# encodeStructuredData

Encodes a structured data message and domain into a SIP-018 encoded hex string. This is the data that gets hashed and signed by `signStructuredData`.

***

### Usage

```ts
import { encodeStructuredData, Cl } from '@stacks/transactions';

const encoded = encodeStructuredData({
  message: Cl.tuple({
    amount: Cl.uint(1000),
  }),
  domain: Cl.tuple({
    name: Cl.stringAscii('my-app'),
    version: Cl.stringAscii('1.0.0'),
    'chain-id': Cl.uint(1),
  }),
});
// hex string: SIP018 prefix + domain hash + message hash
```

#### Notes

* The result is prefixed with the SIP-018 prefix bytes (`SIP018` in ASCII).
* The domain must be a valid tuple with `name`, `version`, and `chain-id` keys.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/structuredDataSignature.ts#L32)

***

### Signature

```ts
function encodeStructuredData(opts: {
  message: ClarityValue;
  domain: ClarityValue;
}): string;
```

***

### Returns

`string`

A hex-encoded string containing the SIP-018 prefix, domain hash, and message hash.

***

### Parameters

#### opts.message (required)

* **Type**: `ClarityValue`

The structured data message.

#### opts.domain (required)

* **Type**: `ClarityValue`

The domain tuple with `name`, `version`, and `chain-id` keys.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/signing/encodestructureddata.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
